<?php
/**
 * (c) 2004-2006 Linbox / Free&ALter Soft, http://linbox.com
 *
 * $Id$
 *
 * This file is part of LMC.
 *
 * LMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * LMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with LMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
?>
<?

/* Printer management */

function addPrinter($printerName, $location, $info) {
    return xmlCall("printing.add", array($printerName, $location, $info));
}

function delPrinter($printerName) {
    return xmlCall("printing.delete", array($printerName));
}

function getPrinters($pattern = null) {
    if ($pattern=='**') { $pattern = null;   }
    return xmlCall("printing.get", $pattern);
}

/* Setting access right to print service */

function setUserPrintServiceAccess($user, $enabled) {
    if ($enabled) return xmlCall("printing.addUserServiceAccessAllowed", array($user));
    else return xmlCall("printing.delUserServiceAccessAllowed", array($user));
}

function setGroupPrintServiceAccess($group, $enabled) {
    if ($enabled) return xmlCall("printing.addGroupServiceAccessAllowed", array($group));
    else return xmlCall("printing.delGroupServiceAccessAllowed", array($group));
}

function isUserServiceAccessAllowed($user) {
    return xmlCall("printing.isUserServiceAccessAllowed", array($user));
}

function isGroupServiceAccessAllowed($group) {
    return xmlCall("printing.isGroupServiceAccessAllowed", array($group));
}

function getUserPrintersAccessAllowed($user) {
    return xmlCall("printing.getUserPrintersAccessAllowed", array($user));
}

function getGroupPrintersAccessAllowed($group) {
    return xmlCall("printing.getGroupPrintersAccessAllowed", array($group));
}

/* Setting full access right to print service */

function setUserPrintServiceAllRights($user, $enabled) {
    if ($enabled) return xmlCall("printing.addUserServiceAllRights", array($user));
    else return xmlCall("printing.delUserServiceAllRights", array($user));
}

function setGroupPrintServiceAllRights($group, $enabled) {
    if ($enabled) return xmlCall("printing.addGroupServiceAllRights", array($group));
    else return xmlCall("printing.delGroupServiceAllRights", array($group));
}

function isUserPrintServiceAllRights($user) {
    return xmlCall("printing.isUserServiceAllRights", array($user));
}

function isGroupPrintServiceAllRights($group) {
    return xmlCall("printing.isGroupServiceAllRights", array($group));
}

/* Setting access to a printer */

function setUserPrinterAccess($user, $printer, $enabled) {
    if ($enabled) return xmlCall("printing.addUserPrinterAccessAllowed", array($user, $printer));
    else return xmlCall("printing.delUserPrinterAccessAllowed", array($user, $printer));
}

function setGroupPrinterAccess($group, $printer, $enabled) {
    if ($enabled) return xmlCall("printing.addGroupPrinterAccessAllowed", array($group, $printer));
    else return xmlCall("printing.delGroupPrinterAccessAllowed", array($group, $printer));
}

function getUsersAccessForPrinter($printer) {
    return xmlCall("printing.getUsersAccessAllowedForPrinter", array($printer));
}

function getGroupsAccessForPrinter($printer) {
    return xmlCall("printing.getGroupsAccessAllowedForPrinter", array($printer));
}

/* Get users and groups member of a GPO */

function getUsersGPO($gpo) {
    return xmlCall("printing.getUsersPrintServiceGPO", array($gpo));
}

function getGroupsGPO($gpo) {
    return xmlCall("printing.getGroupsPrintServiceGPO", array($gpo));
}

function getGroupsServiceAllRights() {
    return getGroupsGPO("GPOPrintServiceAllRights");
}

function getGroupsServiceAllowed() {
    return getGroupsGPO("GPOPrintServiceAccessAllowed");
}

/* To delete */

function setGlobalRights($user, $rights) {
    return xmlCall("printing.setGlobalRights", array($user, $rights));
}

function makeCheckBoxDict($rights) {
    $priorities = array("ignored" => "0", "default" => 1, "forced" => 2);
    $values = array("" => "False", "on" => "True");

    $access = False;
    $paccess = -1;

    if (isset($rights["access"])) {
        if ($rights["access"][1] == "True") {
            $access = True;
            $accesschecked = "CHECKED";
        }
        $paccess = $rights["access"][0];
        switch ($paccess) {
        case $priorities["ignored"]: $selected_ignored = "SELECTED"; break;
        case $priorities["default"]: $selected_default = "SELECTED"; break;
        case $priorities["forced"]: $selected_forced = "SELECTED"; break;
        default: $selected_ignored = "SELECTED"; break;
        }
    } else {
        $selected_ignored = "SELECTED";
    }
    return array(
                 "rights" => $rights,
                 "access" => $access,
                 "paccess" => $paccess,
                 "accesschecked" => $accesschecked,
                 "selected_ignored" => $selected_ignored,
                 "selected_default" => $selected_default,
                 "selected_forced" => $selected_forced
                 );
}

function getGlobalRights($user) {
    $rights = xmlCall("printing.getGlobalRights", $user);
    return makeCheckBoxDict($rights);
}

function getUserRightsOnPrinter($user, $printer) {
    $rights = xmlCall("printing.getUserRightsOnPrinter", array($user, $printer));
    return makeCheckBoxDict($rights);
}

function setUserRightsOnPrinter($user, $printer, $rights) {
    return xmlCall("printing.setUserRightsOnPrinter", array($user, $printer, $rights));
}

function getGroupRightsOnPrinter($group, $printer) {
    $rights = xmlCall("printing.getGroupRightsOnPrinter", array($group, $printer));
    return makeCheckBoxDict($rights);
}

function setGroupRightsOnPrinter($group, $printer, $rights) {
    return xmlCall("printing.setGroupRightsOnPrinter", array($group, $printer, $rights));
}

function getErrorDescription($section) {
    $error = array();
    $error["add"] = array();
    $error["add"]["LDAP.ALREADY_EXISTS"] = "Cette file d'impression existe déjà.";
    $error["delete"]["LDAP.NO_SUCH_OBJECT"] = "Cette file d'impression n'existe pas. Impossible de la supprimer.";

    global $errorDesc;
    return $error[$section][$errorDesc];
}

?>