<?php
/**
 * (c) 2004-2006 Linbox / Free&ALter Soft, http://linbox.com
 *
 * $Id$
 *
 * This file is part of LMC.
 *
 * LMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * LMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with LMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

require("modules/printing/includes/xmlrpc.php");
require("modules/base/includes/groups-xmlrpc.inc.php");
require("localSidebar.php");
require("graph/navbar.inc.php");

global $error;
$queuename = array("value" => "");
$location = array("value" => "");
$info = array("value" => "");

$p = new PageGenerator(_T("Add a printer queue"));
$p->setSideMenu($sidemenu);
$p->display();

if (isset($_POST["add"])) {
    $queuename["value"] = $_POST["queuename"];
    if (strlen($queuename["value"]) < 3) {
        $error .= _T("Printer queue name is too short.")."<br/>";
        setFormError("queuename");
    } else {
        $queue = $queuename["value"];
        $form = new Form();
	$form->addSummary(sprintf(_T("Would you create user group <b>%s</b> to manage rights on this printer queue ? All members of this group will be able to print on this queue."), $queue));
	$form->add(New HiddenTpl("queuename"), array("value" => $queue, "hide" => True));
	$form->add(New HiddenTpl("location"), array("value" => $_POST["location"], "hide" => True));
	$form->add(New HiddenTpl("info"), array("value" => $_POST["info"], "hide" => True));
	$form->addButton("addokno", _T("No"));
	$form->addButton("addokyes", _T("Yes"));
	$form->display();
    }
} else if (isset($_POST["addokno"]) || isset($_POST["addokyes"])) {
    $queuename["value"] = $_POST["queuename"];
    $location["value"] = $_POST["location"];
    $info["value"] = $_POST["info"];
    addPrinter($queuename["value"], $location["value"], $info["value"]);
    global $errorStatus;
    if ($errorStatus) $error .= getErrorDescription("add");
    else {
        $result = _T("Printer queue successfully created");
        if (isset($_POST["addokyes"])) {
            # A group must be created
            $error2 = "";
            $result2 = create_group($error2, $queuename["value"]);
            change_group_desc($queuename["value"],sprintf(_T("Users with rights on the printing queue %s"),$queuename["value"]));
            if (strlen($error2)) $error .= $error2;
            else {
                $result .= "<br/>" . $result2;
                # We give to this group print rights to the new queue
                setGroupPrintServiceAccess($queuename["value"], True);
                setGroupPrinterAccess($queuename["value"], $queuename["value"], True);
            }
        }
    }
    $queuename = "";
    $location = "";
    $info = "";
    //display error message
    if (isset($result) && !isXMLRPCError()) {
        new NotifyWidgetSuccess($result);
        header("Location: " . urlStrRedirect("printing/printers/index"));
    }
}


if ((isset($_POST["add"]) && isset($error)) || (!isset($_POST["add"]))) {
    print _T("<p>Warning: The printer queue name must exactly correspond to CUPS printer queue name using the CUPSLMC backend</p>");

    $form = new Form();
    $form->push(new Table());
    
    $form->add(new TrFormElement(_T("Queue name"), new InputTpl("queuename")));
    $form->add(new TrFormElement(_T("Printer location"), new InputTpl("location")));
    $form->add(new TrFormElement(_T("Comment"), new InputTpl("info")));

    $form->pop();
    $form->addValidateButton("add");
    $form->display();
}

?>
