<?php
/**
 * (c) 2004-2006 Linbox / Free&ALter Soft, http://linbox.com
 *
 * $Id$
 *
 * This file is part of LMC.
 *
 * LMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * LMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with LMC; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
?>
<?

$title = _T("Printers right by group");

$path = array(array("name" => _("Home"),
                    "link" => "index.php"),
              array("name" => _T("Printers"),
                    "link" => "main.php?module=printers&submod=printers&action=index"),
              array("name" => _T("Rights by group"),
                    "link" => "main.php?module=printers&submod=printers&action=bygroup"),
              array("name" => "$title"));

require("localSidebar.php");
require("graph/navbar.inc.php");
require("modules/printing/includes/xmlrpc.php");

$group = $_GET["group"];

print "<h2>$title <b>$group</b></h2>";
print '<div class="fixheight"></div>';

$p = new PageGenerator();
$p->setSideMenu($sidemenu);
$p->displaySideMenu();

if (!strlen($group)) {
    $error = _T("Invalid group name.");
    print "<div id=\"errorCode\">$error</div>";
    exit;
}

function validate($group) {
    $printers = getPrinters();
    $access = $_POST["access"];
    if (strlen($access)) setGroupPrintServiceAccess($group, True);
    else {
        /* Group has access to nothig */
        setGroupPrintServiceAccess($group, False);
        setGroupPrintServiceAllRights($group, False);
        foreach($printers as $idx => $printer)
            setGroupPrinterAccess($group, $printer, False);
    }
    $fullaccess = $_POST["fullaccess"];
    if (strlen($fullaccess)) {
        setGroupPrintServiceAllRights($group, True);
        foreach($printers as $idx => $printer)
            setGroupPrinterAccess($group, $printer, False);
    } else setGroupPrintServiceAllRights($group, False);
}

if (isset($_POST["baddqueue"])) {
    validate($group);
    foreach($_POST["queues"] as $idx => $queue)
        setGroupPrinterAccess($group, $queue, True);
}

if (isset($_POST["bdelqueue"])) {
    validate($group);
    foreach($_POST["aqueues"] as $idx => $queue)
        setGroupPrinterAccess($group, $queue, False);
}

if (isset($_POST["validate"])) {
    validate($group);
}

$printers = getPrinters();
$groupprinters = getGroupPrintersAccessAllowed($group);

if (isGroupServiceAccessAllowed($group)) {
    $accesschecked = "CHECKED";
    $accessdisplay = "inline";
} else $accessdisplay = "none";

if (isGroupPrintServiceAllRights($group)) {
    $fullaccesschecked = "CHECKED";
    $fullaccessdisplay = "none";
} else $fullaccessdisplay = "inline";

//display error message
if (isset($error))
    print "<div id=\"errorCode\">$error</div>";

?>

<script language="javascript">

function localtoggle(id) {

 var state = document.getElementById(id).style.display;
 if (state == "none") state = "inline";
 else state = "none";
 document.getElementById(id).style.display = state;
}
</script>

<form method="POST">

<table>
 <tr>
  <td width="50%"><?= _T("This group has access rights on printing system"); ?></td>
  <td>
 <input type="checkbox" name="access" onClick="localtoggle('access')" <?= $accesschecked ?>/>
  </td>
 </tr>
</table>

<div id="access" style="display:<?= $accessdisplay; ?>">
<table>

 <tr>
  <td width="50%"><?= _T("This group can access without restrictions on all printer's queues") ?></td>
  <td>
    <input type="checkbox" name="fullaccess" onClick="localtoggle('fullaccess')" <?= $fullaccesschecked ?>/>
  </td>
 </tr>
</table>


<style type="text/css">
<!--

#fullaccess div.list
{
        float: left;
}

select.list
{
        width: 250px;
}

-->
</style>


<div id="fullaccess" style="display:<? echo $fullaccessdisplay ?> ">
<table style="border: none;" cellspacing="0">
<tr><td style="border: none;">
  <div class="list">
        <h3><?= _T("All printer's queues");?></h3>
    <select multiple size="10" class="list" name="queues[]">

<?php
foreach ($printers as $idx => $printer)
{
    $idx = array_search($printer, $groupprinters);
    if ($idx === false) echo "<option value=\"".$printer."\">".$printer."</option>\n";
}
?>
    </select>

    <br>

  </div>
  </td><td style="border: none;">
  <div style="text-align:center;">

  <input type="image" name="bdelqueue" style="padding: 5px;" src="img/common/icn_arrowleft.gif"><br/>
  <input type="image" name="baddqueue" style="padding: 5px;" src="img/common/icn_arrowright.gif">

  </div>
  </td><td style="border: none;">

  <div class="list" style="padding-left: 80px;">
      <h3>Files autorisées</h3>
    <select multiple size="10" class="list" name="aqueues[]">
<?php
foreach ($groupprinters as $idx => $printer)
{
  echo "<option value=\"".$printer."\">".$printer."</option>\n";
}
?>
    </select>

    <br>

  </div>
  <div class="clearer"></div>
  </td></tr>
</table>
</div>

</div> <!-- with id="access" -->

<input class="btnPrimary" name="validate" type="submit" value="<?= _T("Confirm"); ?>">
</form>

